function y=huffdeco(QT,QM);
// HUFFDECODE
//		Y=HUFFDECODE(QT,QM);
//		Decoding of a huffman coded binary sequence
//		QT	:	The coded binary sequence as string
//		QM	:	The code table
//		Y	:	The decoded output signal

SB=[];							// Array which will contain symbols
CDTAB=[];						// String Array with Codes
for p=1:1:size(QM,1),			// Analyze the code table and build up Arrays
	K=strindex(QM(p,1),':');
	symbol=eval(part(QM(p,1),1:1:K(1)-1));
	SB=[SB,symbol];
	bits=part(QM(p,1),K(1)+1:1:K(2)-1);
	CDTAB=[CDTAB;bits];
end

kz=1:1:length(SB);
y=[];
spos=1;							// column counter for code table
zz=1;							// counter
kzakt=kz;						// selection index

while zz<=length(QT),
	qakt=part(QT,zz);
	
								// Walking through the tree
	kzakt=kzakt(part(CDTAB(kzakt,1),spos)==qakt);
	if length(kzakt)==1,
		y=[y,SB(kzakt)];
		kzakt=kz;
		spos=1;
	else
		spos=spos+1;
	end
	zz=zz+1;
end

endfunction;